#define BEAM 100                /* beam width for new_analyse() */

#define NEW_ANALYSE     0

short **psi_list;
short **psi_list_new;
short **psi_list_tmp;
float *mult_list;
float *mult_list_new;
float *mult_list_tmp;
int tnum_list[BEAM + 1];
short *tvals_list[BEAM + 1];


void
do_allocations ()
{
  int i;

  ...

  mult_list = (float *) malloc ((unsigned) ((BEAM + 1) * sizeof (float)));
  mult_list_new = (float *) malloc ((unsigned) ((BEAM + 1) * sizeof (float)));
  psi_list = (short **) malloc ((unsigned) ((BEAM + 1) * sizeof (short *)));
  psi_list_new = (short **) malloc ((unsigned) ((BEAM + 1) * sizeof (short *)));  for (i = 0; i <= BEAM; i++) {
    psi_list[i] = (short *) malloc ((unsigned) ((SA + 1) * sizeof (short)));
    psi_list_new[i] = (short *) malloc ((unsigned) ((SA + 1) * sizeof (short)));    tvals_list[i] = (short *) malloc ((unsigned) ((SA + 1) * sizeof (short)));
  }


float
new_analyse (sample)
     int sample;
{
  /* Guess number of trials required for given pi
   * assuming setup(SA) has been called)
   * search a beam of sample width.
   * NB This tends to horribly underestimate the search space size!!
   */
  int rho;
  register short rp, n, t, np;
  register int ii, j, k, numrels;
  int i;
  int psi_size, new_size, p, q;
  int accept, accepted, extendables;
  short *save_psi;
  float result;

  trials = 0;
  save_psi = psi;
  for (i = 1; i <= sample; i++) {
    mult_list[i] = 1;
  }
  psi_size = 1;
  result = 0;
  for (n = 1; n <= SA; n++) {
    /* calculate no. of extensions to each elt of psi_list,
     * store in tnum_list[i] and tvals_list[i][1..tnum_list[i]]:
     */
    new_size = 0;               /* total no of extensions */
    extendables = 0;            /* no of paths which can be extended */
    for (i = 1; i <= psi_size; i++) {
      psi = psi_list[i];
      tnum_list[i] = 0;
      for (t = 1; t <= SB; t++) {
        trials = trials + 1;
 
#include "relpres.c"
/* Uses np, rho, ii and numrels to calculate relpres(psi,t,n)
 * Returns result in rp
 */
 
        if (rp == 1) {
          new_size++;
          tnum_list[i]++;
          tvals_list[i][tnum_list[i]] = t;
        }                       /* fi */
      }                         /* next t */
      if (tnum_list[i] > 0) {
        extendables++;
      }
    }                           /* next i */
 
    /* Update result using mult_list[1..psi_size]: */
    for (i = 1; i <= psi_size; i++) {
      result += mult_list[i] * SB;
    }
    /* set up psi_new array, either all extensions or just some: */
    if (new_size <= sample) {
      /* can record all the extensions in psi_new */
      p = 0;
      for (i = 1; i <= psi_size; i++) {
        for (j = 1; j <= tnum_list[i]; j++) {
          p++;
          /* copy psi_list[i] to psi_list_new[p] and add extension tvals_list[i][j]: */
          for (k = 1; k < n; k++) {
            psi_list_new[p][k] = psi_list[i][k];
          }
          psi_list_new[p][n] = tvals_list[i][j];
          mult_list_new[p] = mult_list[i];
        }
      }  
      psi_size = p;
    } else {
      /* need to select "sample" extensions out of the new_size
       * possible extensions recorded in tvals_list[1..psi_size]
       */
      p = 0;                    /* psi_list_new pointer = no. of choices accepted */
      q = 0;                    /* no. of choices passed by */
      for (i = 1; i <= psi_size; i++) {
        if (tnum_list[i] > 0) {
          /* decide how many of the tnum_list[i] extensions will be included.
           * Can always include at least one:
           */
          accept = (tnum_list[i] * (sample - p)) / (new_size - q);
          if (accept <= 0) {
            accept = 1;         /* minimum to accept */
          } else {
            /* possibly include an extra one, but make sure there are
             * enough spaces left for the extendables
             */
            if (((accept + p) < (sample - extendables))
                && (rnd (new_size - q) < (tnum_list[i] * (sample - p)
                                          - accept * (new_size - q)))) {
              accept++;
            }
          }  
          /* done this extendable: */
          extendables--;
          accepted = 0;
          for (j = 1; j <= tnum_list[i]; j++) {
            /* decide whether to copy psi_list[i] with extension tvals_list[i][j]
             * into to psi_list_new[p]
             */
            if ((accept - accepted) > rnd (tnum_list[i] - j)) {
              /* Yes, put it in: */
              accepted++;
              p++;
              for (k = 1; k < n; k++) {
                psi_list_new[p][k] = psi_list[i][k];
              }
              psi_list_new[p][n] = tvals_list[i][j];
              /* calculate new multiplier mult_list_new[p] from mult_list[i]
               * and no. of extensions selected
               */
              mult_list_new[p] = mult_list[i] * ((float) tnum_list[i]) / ((float) accept);
            }
            q++;
          }                     /* next j - possible extension to psi_list[i] */          if (accept != accepted) {
            error ("new_analyse", "accept != accepted, accept = %i, accepted = %i\n",
                   accept, accepted);
          }
        }                       /* fi */
      }                         /* next i */
      if (p != sample) {
        error ("new_analyse", "p != sample, p = %i, sample = %i\n", p, sample);
      }
      psi_size = p;             /* update psi_size */
    }                           /* fi */
    /* psi_list_new and mult_list_new are now set up */
    psi_list_tmp = psi_list;
    psi_list = psi_list_new;
    psi_list_new = psi_list_tmp;
    mult_list_tmp = mult_list;
    mult_list = mult_list_new;
    mult_list_new = mult_list_tmp;
  }                             /* next n */
  /* restore psi and return result: */
  psi = save_psi;
  return (result);
}                               /* End of new_analyse(sample) */

